' *****************************************************************
' *                                                               *
' *       Copyright (c) Fast Corporation, 2007                    *
' *                                                               *
' *   All Rights Reserved.  Unpublished rights  reserved  under   *
' *   the copyright laws of the Japan.                            *
' *                                                               *
' *   The software contained on this media  is  proprietary  to   *
' *   and  embodies  the  confidential  technology  of  Fast      *
' *   Corporation.  Possession, use,  duplication  or             *
' *   dissemination of the software and media is authorized only  *
' *   pursuant to a valid written license from Fast Corporation.  *
' *                                                               *
' *****************************************************************

' -----------------------------------------------------------------
' FVX Sample Program
' C_CAO
'
' 쐬 : D.Yamaguchi
'
'  : 2007/02/22 
' -----------------------------------------------------------------

Imports System.Windows.Forms.DialogResult
Imports System.IO
Imports FVDATASLib
Imports Microsoft

Public Class frmMain

    '͈
    Private m_ExeRegion As New FvRectangle

    'rfIfoCXI[vĂ邩
    Private m_blnVideoOpened As Boolean

    'IꂽrfIݒt@C̃tpX
    Private m_strVideoConfFilePath As String

    'ƃfBNg
    Private m_strDirectory As String

    'XY_
    Private m_pStandardPoint As New FvPoint

    '2lvs͈(摜ł̍W)
    Private m_pBlobExeRect As New FvRectangle

    Private Sub frmMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Dim intErr As Integer
        Dim frmVideoConf As New frmSelectVideoConfFile
        Dim frmLicence As New frmLicence

        'ݒpRg[̏
        cmbSearchMode.Items.Add("ʏ̃p^[")   ' NORMAL_PATTERN"
        cmbSearchMode.Items.Add("̃p^[") ' BLACK_LINE_PATTERN"
        cmbSearchMode.Items.Add("̃p^[") ' WHITE_LINE_PATTERN"
        cmbSearchMode.Items.Add("sp^[")   ' UNSTABLE_PATTERN"
        cmbSearchMode.SelectedIndex = 0

        cmbPrecision.Items.Add("ʏ퐸x") ' NORMAL_MODE"
        cmbPrecision.Items.Add("x")   ' HIGH_MODE"
        cmbPrecision.Items.Add("x") ' SUPER_MODE"
        cmbPrecision.SelectedIndex = 0

        With cmbColor    'Fݒ
            .Items.Add("BLACK")
            .Items.Add("WHITE")
            .SelectedIndex = 1
        End With

        With cmbArrange    'o
            .Items.Add("UP_TO_LEFT_RIGHT")
            .Items.Add("UP_TO_RIGHT_LEFT")
            .Items.Add("DOWN_TO_LEFT_RIGHT")
            .Items.Add("DOWN_TO_RIGH_LEFT")
            .Items.Add("LEFT_TO_UP_DOWN")
            .Items.Add("LEFT_TO_DOWN_UP")
            .Items.Add("RIGHT_TO_UP_DOWN")
            .Items.Add("RIGHT_TO_DOWN_UP")
            .SelectedIndex = 0
        End With

        m_blnVideoOpened = False
        btnGrab.Enabled = False

        '͈͂̏lݒ(摜̑Sʂɐݒj
        m_ExeRegion.xs = -1
        m_ExeRegion.xe = -1
        m_ExeRegion.ys = -1
        m_ExeRegion.ye = -1

        'ƃfBNgޔ
        m_strDirectory = Directory.GetCurrentDirectory()

        'gp̊mF
        If frmLicence.ShowDialog() = Yes Then
            'rfIݒt@C̑I
            m_strVideoConfFilePath = ""
            If frmVideoConf.ShowDialog() = OK Then
                m_strVideoConfFilePath = frmVideoConf.strVideoConfFilePath
            End If

            frmDisplayEx.Show()

            If m_strVideoConfFilePath.Length <> 0 Then
                'rfIݒt@CR|[lgɐݒ
                AxFvxVideo1.VideoConfFile = m_strVideoConfFilePath

                'Lv`{[h̃I[v
                Try
                    AxFvxVideo1.OpenDevice()
                Catch ex As System.Exception
                    AxFvxVideo1.GetErrReport(intErr)
                    MsgBox("Lv`{[h̃I[vɎs܂ ErrCode = " + intErr.ToString() & vbCrLf & "摜t@Ĉ݂̗pɂȂ܂B", vbExclamation, "G[")
                    Exit Sub
                End Try

                'VideoConfFile̕ύXOpenDevicesƃgK[h̕ύX܂B
                '̂߁AЃLv`{[hFVC02ł350ms̃ZbgAbv^CKvɂȂ܂
                '{vOł͊ȗ̂߂Ɉꗥ350ms̃ZbgAbv^CmۂĂ܂A
                'ۂ̃vOł͂g̃Lv`{[hɍ킹ĕύXĂB
                Threading.Thread.Sleep(350)

                'GrabSync/GrabASync\bhłImageTCY̕ύXs܂̂ŁA
                '炩ChangeImageSize\bhɂImagẽTCYύXĂĂB
                'i荞݃TCYImagẽTCYႤꍇ̓G[ɂȂ܂j
                AxFvxVideo1.ChangeImageSize(AxFvxImage1.GetOcx())

                Try
                    '捞
                    AxFvxVideo1.GrabSync(AxFvxImage1.GetOcx())
                Catch ex As System.Exception
                    AxFvxVideo1.GetErrReport(intErr)
                    MsgBox("rfI̎捞Ɏs܂ ErrCode = " + intErr.ToString() & vbCrLf & "摜t@Ĉ݂̗pɂȂ܂B", vbExclamation, "G[")
                    Exit Sub
                End Try

                'Lv`{[h̏Ԃۑ
                m_blnVideoOpened = True
                btnGrab.Enabled = True
            End If
        Else
            'uӂ܂vIꂽꍇ̓TvvOI
            End
        End If

        'ʂ̐
        frmDisplayEx.AxFvxDisplayEx1.CreateDisplay()
        '摜\
        frmDisplayEx.AxFvxDisplayEx1.DrawImage(AxFvxImage1.GetOcx())

        '2lv͈͂̏ݒ
        m_pBlobExeRect.xs = 100
        m_pBlobExeRect.xe = 200
        m_pBlobExeRect.ys = 100
        m_pBlobExeRect.ye = 200

    End Sub

    Private Sub frmMain_FormClosed(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles MyBase.FormClosed

        If m_blnVideoOpened = True Then
            'Lv`{[hI[vĂꍇ̓N[Y
            AxFvxVideo1.CloseDevice()
        End If

    End Sub

    '2ls
    Private Sub btnApplyBinLevel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnApplyBinLevel.Click

        Dim intBinLevel As Integer

        If Integer.TryParse(txtBinLevel.Text, intBinLevel) = False Or intBinLevel < 0 Or intBinLevel > 255 Then
            MsgBox("2l臒l0`255͈̔͂œ͂Ă", vbExclamation, "G[")
        Else
            AxFvxChangeImage1.FixedLevel(AxFvxImage1.GetOcx(), AxFvxImage2.GetOcx(), intBinLevel)
            frmDisplayEx.AxFvxDisplayEx1.DrawImage(AxFvxImage2.GetOcx())
        End If

    End Sub

    '͈͂̐ݒ
    Private Sub btnExeRegion_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExeRegion.Click

        Dim intOK As Integer
        Dim dblTemp As Double

        AxFvxROI1.SetRectangle(m_ExeRegion)

        'FvxROIgď͈͑I_CAO\
        AxFvxROI1.UsePoint = False
        AxFvxROI1.MakeROIDialog(AxFvxImage1.GetOcx(), intOK)

        If intOK = 1 And AxFvxROI1.CheckRectangle = 1 Then
            AxFvxROI1.GetRectangle(m_ExeRegion)

            'n_ƏI_tɂȂĂȂǂ`FbN܂
            'FvxROIŋ`f[^ꍇAƉE̍WʒutɂȂĂꍇ(xs > xe, ys > ye)ł
            'ւɂ̂܂܌ʂԂ܂̂łӂB
            If m_ExeRegion.xe < m_ExeRegion.xs Then
                dblTemp = m_ExeRegion.xs
                m_ExeRegion.xs = m_ExeRegion.xe
                m_ExeRegion.xe = dblTemp
            End If
            If m_ExeRegion.ye < m_ExeRegion.ys Then
                dblTemp = m_ExeRegion.ys
                m_ExeRegion.ys = m_ExeRegion.ye
                m_ExeRegion.ye = dblTemp
            End If
        End If

    End Sub

    '2l͈͐ݒ
    Private Sub btnSetBlobExeRect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSetBlobExeRect.Click

        Dim intOK As Integer
        Dim dblTemp As Double

        AxFvxROI1.SetRectangle(m_pBlobExeRect)

        'FvxROIgď͈͑I_CAO\
        AxFvxROI1.UsePoint = False
        AxFvxROI1.MakeROIDialog(AxFvxImage1.GetOcx(), intOK)

        If intOK = 1 And AxFvxROI1.CheckRectangle = 1 Then
            AxFvxROI1.GetRectangle(m_pBlobExeRect)

            'n_ƏI_tɂȂĂȂǂ`FbN܂
            'FvxROIŋ`f[^ꍇAƉE̍WʒutɂȂĂꍇ(xs > xe, ys > ye)ł
            'ւɂ̂܂܌ʂԂ܂̂łӂB
            If m_pBlobExeRect.xe < m_pBlobExeRect.xs Then
                dblTemp = m_pBlobExeRect.xs
                m_pBlobExeRect.xs = m_pBlobExeRect.xe
                m_pBlobExeRect.xe = dblTemp
            End If
            If m_pBlobExeRect.ye < m_pBlobExeRect.ys Then
                dblTemp = m_pBlobExeRect.ys
                m_pBlobExeRect.ys = m_pBlobExeRect.ye
                m_pBlobExeRect.ye = dblTemp
            End If
        End If

    End Sub

    'p^[o^
    Private Sub btnSetPattern_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSetPattern.Click

        Dim pRect As New FvRectangle    'p^[̈̐ݒ
        Dim pPoint As New FvPoint       'p^[_

        Dim intOK As Integer
        Dim dblTemp As Double

        'o^̏`ݒ
        pRect.xs = 100
        pRect.ys = 100
        pRect.xe = 200
        pRect.ye = 200
        AxFvxROI2.SetRectangle(pRect)

        'FvxROIgď͈͑I_CAO\
        AxFvxROI2.MakeROIDialog(AxFvxImage1.GetOcx(), intOK)

        If intOK = 1 And AxFvxROI2.CheckRectangle = 1 Then
            AxFvxROI2.GetRectangle(pRect)

            'n_ƏI_tɂȂĂȂǂ`FbN܂
            'FvxROIŋ`f[^ꍇAƉE̍WʒutɂȂĂꍇ(xs > xe, ys > ye)ł
            'ւɂ̂܂܌ʂԂ܂̂łӂB
            If pRect.xe < pRect.xs Then
                dblTemp = pRect.xs
                pRect.xs = pRect.xe
                pRect.xe = dblTemp
            End If
            If pRect.ye < pRect.ys Then
                dblTemp = pRect.ys
                pRect.ys = pRect.ye
                pRect.ye = dblTemp
            End If

            If AxFvxROI2.CheckPoint = 1 Then
                AxFvxROI2.GetPoint(pPoint)
            Else
                MsgBox("p^[_w肳܂łB" & vbCr & "p^[`̒S_Ƃēo^܂", , "p^[o^")

                pPoint.x = (pRect.xs + pRect.xe) / 2
                pPoint.y = (pRect.ys + pRect.ye) / 2
            End If

            AxFvxPattern1.MakePattern(AxFvxImage1.GetOcx(), pRect, pPoint)
        End If

    End Sub

    'p^[\
    Private Sub btnDispPattern_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDispPattern.Click

        AxFvxPattern1.Disp()

    End Sub

    'p^[̃}XNݒ
    Private Sub btnSetPatternMask_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSetPatternMask.Click

        AxFvxPattern1.DefMask()

    End Sub

    'p^[t@C̕ۑ
    Private Sub btnSavePattern_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSavePattern.Click

        'p^[t@C̊gq͓Ɍ߂Ă܂񂪁A
        ' "pat"gp邱Ƃ𐄏܂
        SaveFileDialog1.InitialDirectory = m_strDirectory
        SaveFileDialog1.Filter = "pattern file(*.pat)|*.pat"
        SaveFileDialog1.DefaultExt = "*.pat"
        SaveFileDialog1.ShowDialog()

        If SaveFileDialog1.FileName.Length <> 0 Then
            Try
                AxFvxPattern1.SavePattrenFileName = SaveFileDialog1.FileName
                AxFvxPattern1.Save()
            Catch ex As Exception
                MsgBox("p^[ۑs", vbExclamation, "G[")
            End Try
        End If

    End Sub

    'p^[t@C̓Ǎ
    Private Sub btnLoadPattern_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLoadPattern.Click

        'p^[t@C̊gq͓Ɍ߂Ă܂񂪁A
        ' "pat"gp邱Ƃ𐄏܂
        OpenFileDialog1.InitialDirectory = m_strDirectory
        OpenFileDialog1.Filter = "pattern file(*.pat)|*.pat"
        OpenFileDialog1.DefaultExt = "*.pat"
        OpenFileDialog1.ShowDialog()

        If OpenFileDialog1.FileName.Length <> 0 Then
            Try
                AxFvxPattern1.LoadPattrenFileName = OpenFileDialog1.FileName
                AxFvxPattern1.Load()
            Catch ex As Exception
                MsgBox("p^[Ǎݎs", vbExclamation, "G[")
            End Try
        End If

    End Sub

    'J摜荞
    Private Sub btnGrab_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGrab.Click

        '摜t@Cǂݍ݂ɂĉ摜TCY
        'ύXĂ\邽߁AChangeImageSizesĂ܂B
        '摜TCYύX\ꍇ́AɈxsΖ肠܂B
        AxFvxVideo1.ChangeImageSize(AxFvxImage1.GetOcx())

        Try
            '捞
            AxFvxVideo1.GrabSync(AxFvxImage1.GetOcx())
        Catch ex As System.Exception
            Dim intErr As Integer
            AxFvxVideo1.GetErrReport(intErr)
            MsgBox("rfI̎捞Ɏs܂ErrCode=" + intErr.ToString(), vbExclamation, "G[")
        End Try

        '摜\
        frmDisplayEx.AxFvxDisplayEx1.DrawImage(AxFvxImage1.GetOcx())

    End Sub

    '摜t@CǍ
    Private Sub btnLoadImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLoadImage.Click

        '_CAOɂĉ摜t@CI
        OpenFileDialog1.InitialDirectory = m_strDirectory
        OpenFileDialog1.Filter = "bitmap file(*.bmp)|*.bmp"
        OpenFileDialog1.DefaultExt = "*.bmp"
        OpenFileDialog1.ShowDialog()

        If OpenFileDialog1.FileName.Length > 0 Then

            'FvxFileAccesspăt@CFvxImageɉ摜Ǎ
            AxFvxFileAccess1.FilePath = OpenFileDialog1.FileName

            Try
                AxFvxFileAccess1.LoadBitmap(AxFvxImage1.GetOcx())
            Catch ex As System.Exception
                Dim intErr As Integer
                AxFvxFileAccess1.GetErrReport(intErr)
                MsgBox("Ǎ݂Ɏs܂B(ErrCode=" & intErr.ToString() & ")", vbExclamation, "ǂݍݎs")
                Exit Sub
            End Try

            '摜^Cv`FbN
            If AxFvxImage1.BitPerPixel <> 8 Or AxFvxImage1.ImageType <> FVXCOMIMAGELib.FVXIMAGE_IMAGE_TYPE.imageGray Then

                MsgBox("8bitOC̉摜ł͂܂", , "error")
                AxFvxImage1.BitPerPixel = 8
                AxFvxImage1.ImageType = FVXCOMIMAGELib.FVXIMAGE_IMAGE_TYPE.imageGray
                AxFvxImage1.ImageWidth = 512
                AxFvxImage1.ImageHeight = 480
            End If

            '摜\
            frmDisplayEx.AxFvxDisplayEx1.DrawImage(AxFvxImage1.GetOcx())
        End If

    End Sub

    '摜t@Cۑ
    Private Sub btnSaveImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSaveImage.Click

        SaveFileDialog1.InitialDirectory = m_strDirectory
        SaveFileDialog1.Filter = "bitmap file(*.bmp)|*.bmp"
        SaveFileDialog1.DefaultExt = "*.bmp"
        SaveFileDialog1.ShowDialog()

        If SaveFileDialog1.FileName.Length > 0 Then
            'FvxFileAccesspFvxImaget@Cɕۑ
            AxFvxFileAccess1.FilePath = SaveFileDialog1.FileName()

            Try
                AxFvxFileAccess1.SaveBitmap(AxFvxImage1.GetOcx())
            Catch ex As System.Exception
                Dim intErr As Integer
                AxFvxFileAccess1.GetErrReport(intErr)
                MsgBox("ۑɎs܂B(ErrCode=" & intErr.ToString() & ")", vbExclamation, "ۑs")
                Exit Sub
            End Try
        End If

    End Sub

    Private Function ApplyChanges() As Integer

        Dim intTemp As Integer
        Dim intMinSize As Integer
        Dim intMaxSize As Integer


        ApplyChanges = -1

        'OCT[` ------------------------------------------------------------
        'p[^ݒ
        'p[^ݒ
        AxFvxCorrelation1.SetInspectArea(m_ExeRegion)                   '͈
        AxFvxCorrelation1.SearchMode = cmbSearchMode.SelectedIndex    'T[`[hiׂȂǂ̃p^[Ɏgpj
        AxFvxCorrelation1.Precision = cmbPrecision.SelectedIndex      'T[`

        '摜̏
        If Integer.TryParse(txtCondition.Text, intTemp) = False Or intTemp < 1 Or intTemp > 9 Then
            MsgBox("Ԃ 1`9 ̊ԂŐݒ肵Ă", vbExclamation, "G[")
            Exit Function
        End If
        AxFvxCorrelation1.Condition = intTemp

        '臒l
        If Integer.TryParse(txtThreshold.Text, intTemp) = False Or intTemp < 10 Or intTemp > 99 Then
            MsgBox("XRA 10`99 ̊Ԃœ͂Ă", vbExclamation, "G[")
            Exit Function
        End If
        AxFvxCorrelation1.ScoreThresh = intTemp

        'r臒l
        If Integer.TryParse(txtMiddleThreshold.Text, intTemp) = False Or intTemp < 10 Or intTemp > 99 Then
            MsgBox("rXRA 10`99 ̊Ԃœ͂Ă", vbExclamation, "G[")
            Exit Function
        End If
        AxFvxCorrelation1.ScoreThresh2 = intTemp

        'T[`
        AxFvxCorrelation1.SearchNum = 1

        '͈͐ڐGĂ̂o邩ǂ
        If chkWndTouch.Checked = True Then
            AxFvxCorrelation1.WindowTouch = FVXCOMCORRELATIONLib.WINDOW_TOUCH_TYPE.ON
        Else
            AxFvxCorrelation1.WindowTouch = FVXCOMCORRELATIONLib.WINDOW_TOUCH_TYPE.OFF
        End If


        '2lʌv ------------------------------------------------------------

        '2l臒lݒ
        '2lImageFvxImage2ɍ쐬
        If Integer.TryParse(txtBinLevel.Text, intTemp) = False Or intTemp < 0 Or intTemp > 255 Then
            MsgBox("2l臒l0`255͈̔͂œ͂Ă", vbExclamation, "G[")
            Exit Function
        Else
            AxFvxChangeImage1.FixedLevel(AxFvxImage1.GetOcx(), AxFvxImage2.GetOcx(), intTemp)
        End If

        'ʐϒl`FbN
        If Integer.TryParse(txtMinSize.Text, intMinSize) = False Or intMinSize < 1 Then
            MsgBox("ŏʐϒl͂Pȏ̐lݒ肵Ă", , "p[^G[")
            Exit Function
        End If
        If Integer.TryParse(txtMaxSize.Text, intMaxSize) = False Or intMinSize >= intMaxSize Then
            MsgBox("ŏʐϒlőʐϒlƂȂ悤ݒ肵Ă", , "p[^G[")
            Exit Function
        End If

        'őEŏʐϐݒ
        AxFvxBlob1.MinSize = intMinSize
        AxFvxBlob1.MaxSize = intMaxSize

        'ΏېFݒ
        If cmbColor.Text = "BLACK" Then
            AxFvxBlob1.Color = FVXCOMBLOBLib.COLOR_TYPE.BLACK_COLOR
        Else
            AxFvxBlob1.Color = FVXCOMBLOBLib.COLOR_TYPE.WHITE_COLOR
        End If

        'xOiojݒ
        Select Case cmbArrange.Text
            Case "UP_TO_LEFT_RIGHT" : AxFvxBlob1.Arrange = FVXCOMBLOBLib.ARRANGE_TYPE.UP_TO_LEFT_RIGHT
            Case "UP_TO_RIGHT_LEFT" : AxFvxBlob1.Arrange = FVXCOMBLOBLib.ARRANGE_TYPE.UP_TO_RIGHT_LEFT
            Case "DOWN_TO_LEFT_RIGHT" : AxFvxBlob1.Arrange = FVXCOMBLOBLib.ARRANGE_TYPE.DOWN_TO_LEFT_RIGHT
            Case "DOWN_TO_RIGHT_LEFT" : AxFvxBlob1.Arrange = FVXCOMBLOBLib.ARRANGE_TYPE.DOWN_TO_RIGHT_LEFT
            Case "LEFT_TO_UP_DOWN" : AxFvxBlob1.Arrange = FVXCOMBLOBLib.ARRANGE_TYPE.LEFT_TO_UP_DOWN
            Case "LEFT_TO_DOWN_UP" : AxFvxBlob1.Arrange = FVXCOMBLOBLib.ARRANGE_TYPE.LEFT_TO_DOWN_UP
            Case "RIGHT_TO_UP_DOWN" : AxFvxBlob1.Arrange = FVXCOMBLOBLib.ARRANGE_TYPE.RIGHT_TO_UP_DOWN
            Case "RIGHT_TO_DOWN_UP" : AxFvxBlob1.Arrange = FVXCOMBLOBLib.ARRANGE_TYPE.RIGHT_TO_DOWN_UP
        End Select

        '͈͐ڐG
        If chkWndTouch.Checked = True Then
            AxFvxBlob1.WindowTouch = FVXCOMBLOBLib.WINDOW_TOUCH_TYPE.ON
        Else
            AxFvxBlob1.WindowTouch = FVXCOMBLOBLib.WINDOW_TOUCH_TYPE.OFF
        End If

        ApplyChanges = 0

    End Function

    'ʒuv
    Private Sub btnSetStandard_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSetStandard.Click

        Dim pSearchResult As New FvSearchResult

        Dim intCount As Integer
        Dim intErr As Integer


        frmDisplayEx.AxFvxDisplayEx1.ClearOverlay()
        frmDisplayEx.AxFvxDisplayEx1.DrawImage(AxFvxImage1.GetOcx())

        'p[^ݒ
        If ApplyChanges() = 0 Then
            Try
                'p^[ݒ
                AxFvxCorrelation1.SetPattern(AxFvxPattern1.GetOcx())

                'T[`s
                AxFvxCorrelation1.Execute(AxFvxImage1.GetOcx(), intCount)

                '͈͂ŕ\
                frmDisplayEx.AxFvxDisplayEx1.PenColor = System.Drawing.Color.FromArgb(0, 0, 255)
                frmDisplayEx.AxFvxDisplayEx1.DrawData(0, m_ExeRegion)

                If intCount > 0 Then
                    'T[`ʂԂŕ\
                    AxFvxCorrelation1.GetResult(0, pSearchResult)
                    frmDisplayEx.AxFvxDisplayEx1.PenColor = System.Drawing.Color.FromArgb(255, 0, 0)
                    frmDisplayEx.AxFvxDisplayEx1.DrawData(0, pSearchResult)

                    '_Ƃēo^
                    m_pStandardPoint.x = pSearchResult.x
                    m_pStandardPoint.y = pSearchResult.y

                    frmDisplayEx.AxFvxDisplayEx1.PenColor = System.Drawing.Color.FromArgb(0, 0, 255)
                    frmDisplayEx.AxFvxDisplayEx1.DrawData(0, m_pBlobExeRect) 'v͈͂̕\

                Else
                    MsgBox("T[`p^܂ł", , "T[`s")
                End If
            Catch ex As Exception
                AxFvxCorrelation1.GetErrReport(intErr)
                MsgBox(GetCorrelationErrMesg(intErr), vbExclamation, "G[")
            End Try
        End If

    End Sub

    's
    Private Sub btnExecute_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExecute.Click

        Dim pSearchResult As New FvSearchResult 'O[T[`̌
        Dim pInpRect As New FvRectangle         '2lvs̈(ACg̍W)
        Dim pBlobResultGroup As New FvBlobResultGroup     '2lv


        Dim dblDiffX As Double  'Y
        Dim dblDiffY As Double

        Dim dblTime As Double   '
        Dim intCount As Integer
        Dim intErr As Integer


        frmDisplayEx.AxFvxDisplayEx1.ClearOverlay()

        'p[^Kp
        If ApplyChanges() = 0 Then
            '------------------------------------------------------------
            'ԑJn
            AxFvxPerformanceCounter1.StartCount()

            'p^[ݒ
            AxFvxCorrelation1.SetPattern(AxFvxPattern1.GetOcx())

            'T[`s
            AxFvxCorrelation1.Execute(AxFvxImage1.GetOcx(), intCount)
            AxFvxCorrelation1.GetErrReport(intErr)

            If intErr = 0 Then
                '͈͂ŕ\
                frmDisplayEx.AxFvxDisplayEx1.PenColor = System.Drawing.Color.FromArgb(128, 128, 255)
                frmDisplayEx.AxFvxDisplayEx1.DrawData(0, m_ExeRegion)

                'T[`ʂԂŕ\
                frmDisplayEx.AxFvxDisplayEx1.PenColor = System.Drawing.Color.FromArgb(255, 0, 0)

                If intCount > 0 Then
                    AxFvxCorrelation1.GetResult(0, pSearchResult)
                    frmDisplayEx.AxFvxDisplayEx1.DrawData(0, pSearchResult)

                    'ʒũYʂZo
                    dblDiffX = pSearchResult.x - m_pStandardPoint.x
                    dblDiffY = pSearchResult.y - m_pStandardPoint.y
                    '2lv͈͂ړ
                    pInpRect.xs = m_pBlobExeRect.xs + dblDiffX
                    pInpRect.ys = m_pBlobExeRect.ys + dblDiffY
                    pInpRect.xe = m_pBlobExeRect.xe + dblDiffX
                    pInpRect.ye = m_pBlobExeRect.ye + dblDiffY
                    AxFvxBlob1.SetInspectArea(pInpRect)
                    frmDisplayEx.AxFvxDisplayEx1.DrawData(0, pInpRect) 'v͈͂̕\

                    '2lApplyChanges̒ŎsĂ
                    frmDisplayEx.AxFvxDisplayEx1.DrawImage(AxFvxImage2.GetOcx())

                    '2lvs
                    AxFvxBlob1.Execute(AxFvxImage2.GetOcx(), intCount)
                    AxFvxBlob1.GetErrReport(intErr)

                    If intErr = 0 Then
                        frmDisplayEx.AxFvxDisplayEx1.PenColor = System.Drawing.Color.FromArgb(0, 0, 255)
                        AxFvxBlob1.GetResult(0, pBlobResultGroup)
                        frmDisplayEx.AxFvxDisplayEx1.DrawData(0, pBlobResultGroup)     'dS_ƊOڒ``

                        txtResult.Text = "Yw : " & VisualBasic.Format(dblDiffX, "0.00") & vbCrLf & _
                                         "Yx : " & VisualBasic.Format(dblDiffY, "0.00") & vbCrLf & vbCrLf & _
                                         "ou[u : " & VisualBasic.Format(intCount) & vbCrLf
                    Else
                        MsgBox(GetBlobErrMesg(intErr) & " (" & intErr & ")", vbExclamation, "QlvG[")
                    End If
                Else
                    MsgBox("T[`p^܂ł", , "G[")
                End If
            Else
                MsgBox(GetCorrelationErrMesg(intErr) & " (" & intErr & ")", vbExclamation, "OCT[`G[")
            End If

            '------------------------------------------------------------
            'ԑI
            AxFvxPerformanceCounter1.StopCount(dblTime)
            txtResult.Text = ": " & VisualBasic.Format(dblTime, "0.00ms") & vbCrLf & vbCrLf & txtResult.Text
        End If

    End Sub

    'Tvs
    Private Sub btnDoSample_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDoSample.Click

        Dim intErr As Integer


        '}X^摜ǂݍ
        AxFvxFileAccess1.FilePath = My.Application.Info.DirectoryPath & "\sample1.bmp"
        AxFvxFileAccess1.LoadBitmap(AxFvxImage1.GetOcx())
        AxFvxFileAccess1.GetErrReport(intErr)
        If intErr <> 0 Then
            MsgBox("sample1.bmpǂݍ߂܂ł")
            Exit Sub
        End If

        frmDisplayEx.AxFvxDisplayEx1.ClearOverlay()
        frmDisplayEx.AxFvxDisplayEx1.DrawImage(AxFvxImage1.GetOcx())
        MsgBox("}X^摜ǂݍ")


        'p^ǂݍ
        AxFvxPattern1.LoadPattrenFileName = My.Application.Info.DirectoryPath & "\sample1.pat"
        AxFvxPattern1.Load()
        AxFvxPattern1.GetErrReport(intErr)
        If intErr <> 0 Then
            MsgBox("sample.patǂݍ߂܂ł")
            Exit Sub
        End If

        '2lv͈͐ݒ
        m_pBlobExeRect.xs = 120
        m_pBlobExeRect.ys = 270
        m_pBlobExeRect.xe = 250
        m_pBlobExeRect.ye = 303

        'ʒu
        btnSetStandard_Click(sender, e)
        MsgBox("p^ݒ聕Qlv̈ݒ聕")

        '摜ǂݍ
        AxFvxFileAccess1.FilePath = My.Application.Info.DirectoryPath & "\sample2.bmp"
        AxFvxFileAccess1.LoadBitmap(AxFvxImage1.GetOcx())
        AxFvxFileAccess1.GetErrReport(intErr)
        If intErr <> 0 Then
            MsgBox("sample2.bmpǂݍ߂܂ł")
            Exit Sub
        End If

        frmDisplayEx.AxFvxDisplayEx1.ClearOverlay()
        frmDisplayEx.AxFvxDisplayEx1.DrawImage(AxFvxImage1.GetOcx())
        MsgBox("摜ǂݍ")

        's
        btnExecute_Click(sender, e)
        MsgBox("ACg2lvs")

    End Sub

    Public Function GetCorrelationErrMesg(ByVal intErr As Integer) As String

        Select Case (intErr)
            Case 0
                GetCorrelationErrMesg = "G["
            Case 5001
                GetCorrelationErrMesg = "p^݂Ă܂B"
            Case 5005
                GetCorrelationErrMesg = "p[^Ⴂ܂B"
            Case 5006
                GetCorrelationErrMesg = "^Ⴂ܂B"
            Case 5007
                GetCorrelationErrMesg = "p^摜̂߁Ao^ł܂B"
            Case 5008
                GetCorrelationErrMesg = "p^ƃ}XÑTCYvĂ܂B"
            Case 5009
                GetCorrelationErrMesg = "p[^NULLlw肳܂B"
            Case 5010
                GetCorrelationErrMesg = "̊mۂɎs܂B"
            Case 5022
                GetCorrelationErrMesg = "p^w肳Ă܂B"
            Case Else
                GetCorrelationErrMesg = "sȃG["
        End Select

    End Function


    Public Function GetPatternErrMesg(ByVal intErr As Integer) As String

        Select Case (intErr)
            Case 0
                GetPatternErrMesg = "G["
            Case 9502
                GetPatternErrMesg = "T|[gĂȂC[W^CvłB"
            Case 9505
                GetPatternErrMesg = "p[^Ⴂ܂B"
            Case 9506
                GetPatternErrMesg = "̌^Ⴂ܂B"
            Case 9510
                GetPatternErrMesg = "̊mۂɎs܂B"
            Case 9531
                GetPatternErrMesg = "pX̎w肪ԈĂ܂B"
            Case 9533
                GetPatternErrMesg = "p^[݂܂B"
            Case 9540
                GetPatternErrMesg = "p^݂܂B"
            Case Else
                GetPatternErrMesg = "sȃG["
        End Select

    End Function

    Public Function GetBlobErrMesg(ByVal intErr As Integer) As String

        Select Case (intErr)
            Case 0
                GetBlobErrMesg = "G["
            Case 3001
                GetBlobErrMesg = "C[WIuWFNgNULLw肳Ă܂B"
            Case 3005
                GetBlobErrMesg = "p[^Ⴂ܂B"
            Case 3006
                GetBlobErrMesg = "̌^Ⴂ܂B"
            Case 3007
                GetBlobErrMesg = "NULLw肳Ă܂B"
            Case 3010
                GetBlobErrMesg = "̊mۂɎs܂B"
            Case 3012
                GetBlobErrMesg = "u[u܂"
            Case 3014
                GetBlobErrMesg = "u[u܂"
            Case Else
                GetBlobErrMesg = "sȃG["
        End Select

    End Function

    Private Sub txtCondition_KeyPress(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles txtThreshold.KeyPress, txtMinSize.KeyPress, txtMiddleThreshold.KeyPress, txtMaxSize.KeyPress, txtCondition.KeyPress, txtBinLevel.KeyPress

        'l̂ݓ͂ł悤ɐ
        If ("0"c <= e.KeyChar And e.KeyChar <= "9"c) Or (e.KeyChar = Chr(&H8)) Then
            e.Handled = False
        Else
            e.Handled = True
        End If

    End Sub
End Class
